<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX Tutorials: vx_tutorial_graph_user_kernel_pytiovx.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
    </ul>
  </div>
<h1>vx_tutorial_graph_user_kernel_pytiovx.c</h1><a href="vx__tutorial__graph__user__kernel__pytiovx_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">*</span>
<a name="l00003"></a>00003 <span class="comment">* Copyright (c) 2017 Texas Instruments Incorporated</span>
<a name="l00004"></a>00004 <span class="comment">*</span>
<a name="l00005"></a>00005 <span class="comment">* All rights reserved not granted herein.</span>
<a name="l00006"></a>00006 <span class="comment">*</span>
<a name="l00007"></a>00007 <span class="comment">* Limited License.</span>
<a name="l00008"></a>00008 <span class="comment">*</span>
<a name="l00009"></a>00009 <span class="comment">* Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive</span>
<a name="l00010"></a>00010 <span class="comment">* license under copyrights and patents it now or hereafter owns or controls to make,</span>
<a name="l00011"></a>00011 <span class="comment">* have made, use, import, offer to sell and sell (&quot;Utilize&quot;) this software subject to the</span>
<a name="l00012"></a>00012 <span class="comment">* terms herein.  With respect to the foregoing patent license, such license is granted</span>
<a name="l00013"></a>00013 <span class="comment">* solely to the extent that any such patent is necessary to Utilize the software alone.</span>
<a name="l00014"></a>00014 <span class="comment">* The patent license shall not apply to any combinations which include this software,</span>
<a name="l00015"></a>00015 <span class="comment">* other than combinations with devices manufactured by or for TI (&quot;TI Devices&quot;).</span>
<a name="l00016"></a>00016 <span class="comment">* No hardware patent is licensed hereunder.</span>
<a name="l00017"></a>00017 <span class="comment">*</span>
<a name="l00018"></a>00018 <span class="comment">* Redistributions must preserve existing copyright notices and reproduce this license</span>
<a name="l00019"></a>00019 <span class="comment">* (including the above copyright notice and the disclaimer and (if applicable) source</span>
<a name="l00020"></a>00020 <span class="comment">* code license limitations below) in the documentation and/or other materials provided</span>
<a name="l00021"></a>00021 <span class="comment">* with the distribution</span>
<a name="l00022"></a>00022 <span class="comment">*</span>
<a name="l00023"></a>00023 <span class="comment">* Redistribution and use in binary form, without modification, are permitted provided</span>
<a name="l00024"></a>00024 <span class="comment">* that the following conditions are met:</span>
<a name="l00025"></a>00025 <span class="comment">*</span>
<a name="l00026"></a>00026 <span class="comment">* *       No reverse engineering, decompilation, or disassembly of this software is</span>
<a name="l00027"></a>00027 <span class="comment">* permitted with respect to any software provided in binary form.</span>
<a name="l00028"></a>00028 <span class="comment">*</span>
<a name="l00029"></a>00029 <span class="comment">* *       any redistribution and use are licensed by TI for use only with TI Devices.</span>
<a name="l00030"></a>00030 <span class="comment">*</span>
<a name="l00031"></a>00031 <span class="comment">* *       Nothing shall obligate TI to provide you with source code for the software</span>
<a name="l00032"></a>00032 <span class="comment">* licensed and provided to you in object code.</span>
<a name="l00033"></a>00033 <span class="comment">*</span>
<a name="l00034"></a>00034 <span class="comment">* If software source code is provided to you, modification and redistribution of the</span>
<a name="l00035"></a>00035 <span class="comment">* source code are permitted provided that the following conditions are met:</span>
<a name="l00036"></a>00036 <span class="comment">*</span>
<a name="l00037"></a>00037 <span class="comment">* *       any redistribution and use of the source code, including any resulting derivative</span>
<a name="l00038"></a>00038 <span class="comment">* works, are licensed by TI for use only with TI Devices.</span>
<a name="l00039"></a>00039 <span class="comment">*</span>
<a name="l00040"></a>00040 <span class="comment">* *       any redistribution and use of any object code compiled from the source code</span>
<a name="l00041"></a>00041 <span class="comment">* and any resulting derivative works, are licensed by TI for use only with TI Devices.</span>
<a name="l00042"></a>00042 <span class="comment">*</span>
<a name="l00043"></a>00043 <span class="comment">* Neither the name of Texas Instruments Incorporated nor the names of its suppliers</span>
<a name="l00044"></a>00044 <span class="comment">*</span>
<a name="l00045"></a>00045 <span class="comment">* may be used to endorse or promote products derived from this software without</span>
<a name="l00046"></a>00046 <span class="comment">* specific prior written permission.</span>
<a name="l00047"></a>00047 <span class="comment">*</span>
<a name="l00048"></a>00048 <span class="comment">* DISCLAIMER.</span>
<a name="l00049"></a>00049 <span class="comment">*</span>
<a name="l00050"></a>00050 <span class="comment">* THIS SOFTWARE IS PROVIDED BY TI AND TI&apos;S LICENSORS &quot;AS IS&quot; AND ANY EXPRESS</span>
<a name="l00051"></a>00051 <span class="comment">* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES</span>
<a name="l00052"></a>00052 <span class="comment">* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.</span>
<a name="l00053"></a>00053 <span class="comment">* IN NO EVENT SHALL TI AND TI&apos;S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT,</span>
<a name="l00054"></a>00054 <span class="comment">* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,</span>
<a name="l00055"></a>00055 <span class="comment">* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span>
<a name="l00056"></a>00056 <span class="comment">* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY</span>
<a name="l00057"></a>00057 <span class="comment">* OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE</span>
<a name="l00058"></a>00058 <span class="comment">* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED</span>
<a name="l00059"></a>00059 <span class="comment">* OF THE POSSIBILITY OF SUCH DAMAGE.</span>
<a name="l00060"></a>00060 <span class="comment">*</span>
<a name="l00061"></a>00061 <span class="comment">*/</span>
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00116"></a>00116 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00117"></a>00117 <span class="preprocessor">#include &lt;VX/vx.h&gt;</span>
<a name="l00118"></a>00118 <span class="preprocessor">#include &lt;TI/tivx.h&gt;</span>
<a name="l00119"></a>00119 <span class="preprocessor">#include &lt;<a class="code" href="utility_8h.html">utility.h</a>&gt;</span>
<a name="l00120"></a>00120 <span class="preprocessor">#include &lt;ch03_graph/vx_tutorial_graph_user_kernel_pytiovx_uc.h&gt;</span>
<a name="l00121"></a>00121 <span class="preprocessor">#include &lt;<a class="code" href="phase__rgb__user__kernel_8h.html">ch03_graph/phase_rgb_user_kernel.h</a>&gt;</span>
<a name="l00122"></a>00122 
<a name="l00124"></a><a class="code" href="vx__tutorial__graph__user__kernel__pytiovx_8c.html#a8118656bb5a60090a1dbffa402168438">00124</a> <span class="preprocessor">#define IN_FILE_NAME                &quot;colors.bmp&quot;</span>
<a name="l00125"></a>00125 <span class="preprocessor"></span>
<a name="l00127"></a><a class="code" href="vx__tutorial__graph__user__kernel__pytiovx_8c.html#a858679d8af857cbb2c1346f4a4bc1c06">00127</a> <span class="preprocessor">#define OUT_USER_KERNEL_FILE_NAME   &quot;vx_tutorial_graph_user_kernel_pytiovx_out.bmp&quot;</span>
<a name="l00128"></a>00128 <span class="preprocessor"></span>
<a name="l00130"></a><a class="code" href="vx__tutorial__graph__user__kernel__pytiovx_8c.html#a9a1d52660f6cc470b9da80d5589808fc">00130</a> <span class="preprocessor">#define OUT_TARGET_KERNEL_FILE_NAME &quot;vx_tutorial_graph_target_kernel_pytiovx_out.bmp&quot;</span>
<a name="l00131"></a>00131 <span class="preprocessor"></span>
<a name="l00138"></a><a class="code" href="vx__tutorial__graph__user__kernel__pytiovx_8c.html#a08ebb111969e2e91e4d36366d138d6ea">00138</a> <span class="keywordtype">void</span> <a class="code" href="vx__tutorial__graph__user__kernel__pytiovx_8c.html#a08ebb111969e2e91e4d36366d138d6ea" title="Tutorial Entry Point.">vx_tutorial_graph_user_kernel_pytiovx</a>(vx_bool add_as_target_kernel)
<a name="l00139"></a>00139 {
<a name="l00140"></a>00140     vx_status status;
<a name="l00148"></a>00148     vx_tutorial_graph_user_kernel_pytiovx_uc_t uc;
<a name="l00156"></a>00156     vx_context context = NULL;
<a name="l00167"></a>00167     <span class="keywordtype">char</span> *out_file = <a class="code" href="vx__tutorial__graph__user__kernel_8c.html#a858679d8af857cbb2c1346f4a4bc1c06" title="Output file name when tutorial is run with user kernel.">OUT_USER_KERNEL_FILE_NAME</a>;
<a name="l00168"></a>00168 
<a name="l00169"></a>00169     <span class="keywordflow">if</span>(add_as_target_kernel)
<a name="l00170"></a>00170     {
<a name="l00171"></a>00171         out_file = <a class="code" href="vx__tutorial__graph__user__kernel_8c.html#a9a1d52660f6cc470b9da80d5589808fc" title="Output file name when tutorial is run with target kernel.">OUT_TARGET_KERNEL_FILE_NAME</a>;
<a name="l00172"></a>00172     }
<a name="l00175"></a>00175     printf(<span class="stringliteral">&quot; vx_tutorial_graph_user_kernel_pytiovx: Tutorial Started !!! \n&quot;</span>);
<a name="l00176"></a>00176 
<a name="l00185"></a>00185     context = vxCreateContext();
<a name="l00202"></a>00202     status = <a class="code" href="phase__rgb__user__kernel_8c.html#a5e51581ab691a0e9037aed069be8495b" title="Add user/target kernel to OpenVX context.">phase_rgb_user_kernel_add</a>(context, add_as_target_kernel);
<a name="l00203"></a>00203     <span class="keywordflow">if</span>(status!=VX_SUCCESS)
<a name="l00204"></a>00204     {
<a name="l00205"></a>00205         printf(<span class="stringliteral">&quot; vx_tutorial_graph_user_kernel_pytiovx: ERROR: unable to add user kernel !!!\n&quot;</span>);
<a name="l00206"></a>00206     }
<a name="l00209"></a>00209     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00210"></a>00210     {
<a name="l00220"></a>00220         vx_tutorial_graph_user_kernel_pytiovx_uc_create(&amp;uc);
<a name="l00230"></a>00230         printf(<span class="stringliteral">&quot; Loading file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>);
<a name="l00231"></a>00231         status = <a class="code" href="utility_8h.html#abb1f44b0f70eb1480ce3ed7dc7bf4e62" title="Load data from BMP file into a previously created vx_image object.">load_image_from_file</a>(uc.input, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>, vx_true_e);
<a name="l00238"></a>00238         <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(uc.input);
<a name="l00239"></a>00239         <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(uc.grad_x);
<a name="l00240"></a>00240         <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(uc.grad_y);
<a name="l00241"></a>00241         <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(uc.phase);
<a name="l00242"></a>00242         <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(uc.phase_rgb);
<a name="l00251"></a>00251         vx_tutorial_graph_user_kernel_pytiovx_uc_verify(&amp;uc);
<a name="l00252"></a>00252         <a class="code" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes</a>(uc.graph_0);
<a name="l00255"></a>00255         <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00256"></a>00256         {
<a name="l00257"></a>00257             printf(<span class="stringliteral">&quot; Executing graph ...\n&quot;</span>);
<a name="l00258"></a>00258 
<a name="l00263"></a>00263             vx_tutorial_graph_user_kernel_pytiovx_uc_run(&amp;uc);
<a name="l00266"></a>00266             printf(<span class="stringliteral">&quot; Executing graph ... Done !!!\n&quot;</span>);
<a name="l00267"></a>00267 
<a name="l00272"></a>00272             <a class="code" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes</a>(uc.graph_0);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274             printf(<span class="stringliteral">&quot; Saving to file %s ...\n&quot;</span>, out_file);
<a name="l00275"></a>00275             <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(out_file, uc.phase_rgb);
<a name="l00277"></a>00277         }
<a name="l00278"></a>00278 
<a name="l00285"></a>00285         vx_tutorial_graph_user_kernel_pytiovx_uc_delete(&amp;uc);
<a name="l00294"></a>00294         <a class="code" href="phase__rgb__user__kernel_8c.html#a25ca1ab2d5d29d7d84d81ddc366a464c" title="Remove user/target kernel from context.">phase_rgb_user_kernel_remove</a>(context);
<a name="l00296"></a>00296     }
<a name="l00297"></a>00297 
<a name="l00303"></a>00303     vxReleaseContext(&amp;context);
<a name="l00306"></a>00306     printf(<span class="stringliteral">&quot; vx_tutorial_graph_user_kernel_pytiovx: Tutorial Done !!! \n&quot;</span>);
<a name="l00307"></a>00307     printf(<span class="stringliteral">&quot; \n&quot;</span>);
<a name="l00308"></a>00308 }
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
